#include "delay.h"
#include <avr/io.h>
#include "DS1820.h"

unsigned short int CRC_Check(int* By0, int* By1, int* By2, int* By3, int* By4, int* By5, int* By6, int* By7)
{
	
}

unsigned short int DS1820_Wandeln()
{
	if(0x00==Reset_DS1820())	//Reset OK
	{
		_delay_ms(1);			//Zeit fr Presence = 500uS
		Byte_Senden(0xCC);		//Skip-Rom
		Byte_Senden(0x44);		//Temperatur Wandeln
		_delay_ms(550*4);		//Zeit zum Wandeln 600ms
		return 0x00;
	}	
	return 0x01;				//--> Reset gab 0x01 zurck
}

unsigned int DS1820_Lesen()
{
	int Temperatur=0x0000;
	if(0x00==Reset_DS1820())	//Reset OK
	{
		_delay_ms(1);			//Zeit fr Presence = 500uS
		Byte_Senden(0xCC);		//Skip-Rom
		Byte_Senden(0xBE);		//Skip-Rom
		B0=Byte_Lesen();
		B1=Byte_Lesen();
		B2=Byte_Lesen();
		B3=Byte_Lesen();
		B4=Byte_Lesen();
		B5=Byte_Lesen();
		B6=Byte_Lesen();
		B7=Byte_Lesen();
		Temperatur=B0;
		if(B1>0x00)				//Positive Temperatur
			Temperatur=Temperatur|0x0100;
		return Temperatur;		//--> Reset gab 0x01 zurck
	}	
	Temperatur=Temperatur|0x0200;//Fehler beim Reset
	return Temperatur;
}

unsigned short int Bit_Empfangen()
{
	unsigned short int  w=0x00;
	DDRB|=0x01;			//Portpin auf LOW / Ausgang
	_delay_us(8*4);
	DDRB&=0xFE;			//Portpin auf HIGH / Eingang
	_delay_us(8*4);		//Abtasten nach 10uS
	if(PINB & (1 << PB0))	//Wenn Pin Wieder auf VCC --> 1
	{
		w=0x01;
	}
	_delay_us(47*4);	//Fr vollstndigen Zyklus weitere 47uS warten
	return(w);
}

unsigned short int Byte_Lesen()
{
	unsigned short int Vergl=0x01;
	unsigned short int Byte=0x00;
	unsigned short int Bit=0x00;
	for(int i=0;i<=7;i++,Vergl=Vergl*2)
	{
		Bit=Bit_Empfangen();
		if(Bit>0x00)
		{
			Byte|=Vergl;
		}
	}
	return (Byte);
}

unsigned short int Reset_DS1820()
{
	unsigned short int OK=0x00;
	PORTD|=0x40;			//Setzen
	DDRB|=0x01;				//Portpin auf LOW / Ausgang
	_delay_us(500*4);
	DDRB&=0xFE;				//Portpin auf HIGH / Eingang
	_delay_us(60*4);		//Abtasten nach 60uS
	PORTD&=0xBF;			//Rcksetzen
	if(PINB & (1 << PB0))	//Wenn Pin Wieder auf VCC --> Nicht OK
	{
		OK=0x01;
	}
	PORTD|=0x40;			//Setzen
	_delay_us(100*4);//200uS Warten
	PORTD&=0xBF;			//Rcksetzen
	if(OK==0x00)
	{
		return 0x00;		//OK
	}
	return 0x01;			//DS1820 meldet sich nicht
}

void Byte_Senden(unsigned short int Byte)
{
	unsigned short int Vergleich = 0x01;
	for(int i=8;i>=1;Vergleich=Vergleich*2, i--)
	{
		if(Byte & Vergleich)	//1 Senden
		{
			Bit_Senden(1);
		}
		else					//0 Senden
		{
			Bit_Senden(0);
		}
	}
}

void Bit_Senden(int sequenz)	//0 = 0 / 1 = 1 / 2 = Reset
{
	switch(sequenz)
	{
		case 0:				//0 Senden
			DDRB|=0x01;		//Portpin auf LOW / Ausgang
			_delay_us(65*4);
			DDRB&=0xFE;		//Portpin auf LOW / Ausgang
		break;
		case 1:				//1 Senden
			DDRB|=0x01;		//Portpin auf LOW / Ausgang
			_delay_us(8*4);
			DDRB&=0xFE;		//Portpin auf HIGH / Eingang
			_delay_us(57*4);
		break;
	}
}