/*
 * Uhr_7Seg.c
 *
 * Created: 05.03.2014 10:29:46
 *  Author: 
 */ 

#include <avr/io.h>
#include <avr/interrupt.h>
#include "delay.h"
#include "DS1820.h"

int Einer_Sek=0;			//Uhrzeit
int Zehne_Sek=0;
int Einer_Min=0;
int Zehne_Min=0;
int Einer_Std=0;
int Zehne_Std=0;
int W_Einer_Sek=0;			//Weckzeit
int W_Zehne_Sek=0;
int W_Einer_Min=0;
int W_Zehne_Min=0;
int W_Einer_Std=0;
int W_Zehne_Std=0;
int Z=0;
int A=0;



unsigned short int C=20;
unsigned short int C_Halbe=0;
unsigned short int C_Einer=0;
unsigned short int C_Zehner=0;
unsigned short int VZ=0;
unsigned short int Leer=21;

unsigned int Gel_Temp=0;

ISR(TIMER1_COMPA_vect)
{
	Uhr(&Einer_Sek,&Zehne_Sek,&Einer_Min,&Zehne_Min,&Einer_Std,&Zehne_Std);
}

void Temperatur_Ausgeben()
{
	unsigned int temp=0;
	temp=Gel_Temp&0x00FF;		//Untere 8Bit mit temperatur Kopieren
	if(temp%2)	//Wenn Rest --> +0.5C
	{
		C_Halbe=5;
	}
	else
	{
		C_Halbe=0;
	}
	temp=temp/2;		//Wandlung zu ganzen C
	C_Einer=temp%10;	//Rest von 10
	temp=temp/10;
	C_Zehner=temp%10;
	if(Gel_Temp&0x0100)	{VZ=22;}
	else				{VZ=21;}
	Ausgabe(&C,&C_Halbe,&C_Einer,&C_Zehner,&VZ,&Leer);
}

int main(void)
{
	Init();
	DDRD|=0x40;				//Triggerung fr Oszi
	PORTB&=FE;				//PORTB.0=0
	TIMSK|=0x02;			//Interrupt Timer0 Enable
	while(1)
	{	
		if(0x00==DS1820_Wandeln())
		{	
			Gel_Temp=DS1820_Lesen();
			if(Gel_Temp==0x0200)	//Fehler beim Reset 
			{
				while(1){;}
			}
			for(int i=0;i<10000;i++)
				Temperatur_Ausgeben();
		}
		else						//Fehler beim Reset
		{
			while(1) {;}	
		}
	}
}

void Stellen()
{
	if(!(PINB&0x02))		//Schnell-Stellen
	{
		S_Stellen(&Einer_Sek,&Zehne_Sek,&Einer_Min,&Zehne_Min,&Einer_Std,&Zehne_Std);
	}	
	if(!(PINB&0x04))		//Langsam-Stellen
	{
		L_Stellen(&Einer_Sek,&Zehne_Sek,&Einer_Min,&Zehne_Min,&Einer_Std,&Zehne_Std);
	}	
	if(!(PINB&0x08))		//Alarm Aus / Alarm an / Weckzeit-Stellen
	{	
		Alarm_Einst();
	}
	else
	{
		Ausgabe(&Einer_Sek,&Zehne_Sek,&Einer_Min,&Zehne_Min,&Einer_Std,&Zehne_Std);
	}
}

void Alarm_Einst()
{
	switch(A)
	{
		case 0:			//Alarm AN, Es soll die Zeit Ausgegeben werden, 100ms Tastersperrung
			A=1;		
			for(int i=0;i<2000;i++)
			{
				Ausgabe(&Einer_Sek,&Zehne_Sek,&Einer_Min,&Zehne_Min,&Einer_Std,&Zehne_Std);
				_delay_ms(1);
			}
		break;
		case 1:			//Alarm AUS, Zeit Ausgegeben , 100ms Tastersperrung
			A=2;	
			for(int i=0;i<2000;i++)
			{
				Ausgabe(&Einer_Sek,&Zehne_Sek,&Einer_Min,&Zehne_Min,&Einer_Std,&Zehne_Std);
				_delay_ms(1);
			}	
		break;
		case 2:			//Alarm AUS, Weckzeit Einstellen
						//Solange hier bleiben bis nochmal gedrckt wird
			A=0;	
			for(int i=0;i<2000;i++)		//Entprellung
			{
				Ausgabe(&W_Einer_Sek,&W_Zehne_Sek,&W_Einer_Min,&W_Zehne_Min,&W_Einer_Std,&W_Zehne_Std);
				_delay_ms(1);
			}	
			do
			{
				if(!(PINB&0x02))		//Schnell-Stellen
				{
					S_Stellen(&W_Einer_Sek,&W_Zehne_Sek,&W_Einer_Min,&W_Zehne_Min,&W_Einer_Std,&W_Zehne_Std);
				}
				if(!(PINB&0x04))		//Langsam-Stellen
				{
					L_Stellen(&W_Einer_Sek,&W_Zehne_Sek,&W_Einer_Min,&W_Zehne_Min,&W_Einer_Std,&W_Zehne_Std);
				}
				Ausgabe(&W_Einer_Sek,&W_Zehne_Sek,&W_Einer_Min,&W_Zehne_Min,&W_Einer_Std,&W_Zehne_Std);
			}while (PINB&0x08);	//Solange bis nochmal gedrckt wird
		break;
	}	
}

void Wecken()
{
	if(A==1)
	{
		while((Einer_Std==W_Einer_Std) && (Zehne_Std==W_Zehne_Std) &&
			(Einer_Min==W_Einer_Min) && (Zehne_Min==W_Zehne_Min) && (PINB&0x08))
		{
			for(int i=0;i<2000;i++)
			{
				PORTC=0x00;
				PORTA=0xFF;
				_delay_ms(1);
			}			
			for(int i=0;i<3000;i++)
			{
				Ausgabe(&Einer_Sek,&Zehne_Sek,&Einer_Min,&Zehne_Min,&Einer_Std,&Zehne_Std);
				_delay_ms(1);
			}				
		}
	}
}

void L_Stellen(int* ES, int* ZS, int* EM, int* ZM, int* ESt, int* ZSt)		//Langsames Stellen
{
	Uhr(ES,ZS,EM,ZM,ESt,ZSt);	
	for(int i=0;i<40;i++)
	{
		Ausgabe(ES,ZS,EM,ZM,ESt,ZSt);
		_delay_ms(1);
	}
}

void S_Stellen(int* ES, int* ZS, int* EM, int* ZM, int* ESt, int* ZSt)		//Schnelles Stellen 
{
	Uhr(ES,ZS,EM,ZM,ESt,ZSt);
	Ausgabe(ES,ZS,EM,ZM,ESt,ZSt);
	_delay_ms(1);
}

void Init()
{
	TCNT1H=0x00;	//Timer auf  0
	TCNT1L=0x00;
	OCR1A = 15624;
	TCCR1A=0x00;	//Kein WPM	/ Keine Ansteuerung von Pins
	sei();
	TIMSK |= (1<<OCIE1A);		//Interrupt Enable
	//TCCR1B=0x0C;	//=00001100	/ CTC-Modus, Prescaler = 256, Starten
	DDRA=0xFF;
	DDRB=0x00;		//Eingang
	DDRC=0xFC;
	DDRD=0x00;
}

void Uhr(int* ES, int* ZS, int* EM, int* ZM, int* ESt, int* ZSt)
{
	*ES=*ES+1;
	if(*ES==10)
	{
		*ES=0;
		*ZS=*ZS+1;
		if(*ZS==6)
		{
			*ZS=0;
			*EM=*EM+1;
			if(*EM==10)
			{
				*EM=0;
				*ZM=*ZM+1;
				if(*ZM==6)
				{
					*ZM=0;
					*ESt=*ESt+1;
					if(*ESt==10)
					{
						*ESt=0;
						*ZSt=*ZSt+1;
					}	
					if((*ZSt==2) && (*ESt==4))
					{
						*ZSt=0;
						*ESt=0;
					}
				}
			}
		}
	}
}

void Ausgabe(int* ES, int* ZS,int* EM,int* ZM,int* ESt,int* ZSt)
{		
	Z++;
	PORTC=0x00;
	PORTA=0xFF;
	switch(Z)
	{
	case 0:	
		PORTC=0x04;		//Einer Sek
		BCDDecode(*ES);
	break;
	case 1:
		PORTC=0x08;		//Zehne Sek
		BCDDecode(*ZS);
	break;
	case 2:	
		PORTC=0x10;		//Einer Min
		BCDDecode(*EM);
	break;
	case 3:	
		PORTC=0x20;		//Zehne Min
		BCDDecode(*ZM);
	break;
	case 4:
		PORTC=0x40;		//Einer Std
		BCDDecode(*ESt);
	break;
	case 5:	
		PORTC=0x80;		//Zehne Std
		if(A==1)
			BCDDecode((*ZSt+10));
		BCDDecode(*ZSt);
		Z=-1;
	break;
	}
}

void BCDDecode(int Wert)
{
	switch(Wert)
	{
	case 0: PORTA= 0x81;	break;
	case 1: PORTA= 0xB7;	break;
	case 2: PORTA= 0xC2;	break;
	case 3: PORTA= 0x92;	break;
	case 4: PORTA= 0xB4;	break;
	case 5: PORTA= 0x98;	break;
	case 6: PORTA= 0x88;	break;
	case 7: PORTA= 0xB3;	break;
	case 8: PORTA= 0x80;	break;
	case 9: PORTA= 0x90;	break;
	case 10: PORTA= 0x01;	break;
	case 11: PORTA= 0x37;	break;
	case 12: PORTA= 0x42;	break;
	case 13: PORTA= 0x12;	break;
	case 14: PORTA= 0x34;	break;
	case 15: PORTA= 0x18;	break;
	case 16: PORTA= 0x08;	break;
	case 17: PORTA= 0x33;	break;
	case 18: PORTA= 0x00;	break;
	case 19: PORTA= 0x10;	break;
	case 20: PORTA= 0xF0;	break; //
	case 21: PORTA= 0xFF;	break; //Leer
	case 22: PORTA= 0xFE;	break; //Minus
	default: PORTA= 0x12;	break; //-->3.
	}
}